"""
Created on 2023/08/15 23:56:48
"""
class TECH_Lyr_Init(object):
	def __init__(self):
		
# This Tech file is extracted from G:\develop\picpalette\tech\SITRI_Tech.csv
		
		self.HARDMASK = [1, 0]  # 
		self.WG = self.HARDMASK  # General Definition: 
		self.WG3COR = self.HARDMASK  # Owner Definition: 
		
		self.RIBWG = [2, 0]  # 
		self.RB = self.RIBWG  # General Definition: 
		
		self.STRIPWG = [3, 0]  # 
		self.SP = self.STRIPWG  # General Definition: 
		
		self.P = [13, 0]  # 
		self.PB = self.P  # General Definition: 
		
		self.N = [14, 0]  # 
		self.NB = self.N  # General Definition: 
		
		self.PM = [15, 0]  # 
		
		self.NM = [16, 0]  # 
		
		self.PH = [11, 0]  # 
		self.PPLUS = self.PH  # General Definition: 
		
		self.NH = [12, 0]  # 
		self.NPLUS = self.NH  # General Definition: 
		
		self.P_PD = [17, 0]  # 
		self.PP = self.P_PD  # General Definition: 
		
		self.N_PD = [18, 0]  # 
		self.NP = self.N_PD  # General Definition: 
		
		self.GeW = [20, 0]  # 
		self.GE = self.GeW  # General Definition: 
		
		self.GeNP = [21, 0]  # 
		self.GN = self.GeNP  # General Definition: 
		
		self.GePP = [22, 0]  # 
		self.GP = self.GePP  # General Definition: 
		
		self.CTSI = [35, 0]  # 
		self.CS = self.CTSI  # General Definition: 
		
		self.CTGE = [36, 0]  # 
		self.CG = self.CTGE  # General Definition: 
		
		self.M1 = [40, 0]  # 
		self.M1D = self.M1  # Owner Definition: 
		self.M1DRW = self.M1  # Owner Definition: 
		
		self.TiN = [45, 0]  # 
		self.HT = self.TiN  # General Definition: 
		self.MHD = self.TiN  # Owner Definition: 
		self.MHDRW = self.TiN  # Owner Definition: 
		
		self.VIA1 = [50, 0]  # 
		self.V1 = self.VIA1  # General Definition: 
		self.VIA12 = self.VIA1  # Owner Definition: 
		
		self.M2 = [55, 0]  # 
		self.M2D = self.M2  # Owner Definition: 
		self.M2DRW = self.M2  # Owner Definition: 
		
		self.AlPAD = [66, 0]  # 
		self.PAD = self.AlPAD  # General Definition: 
		self.PADOPEN = self.AlPAD  # Owner Definition: 
		
		self.DIOPEN = [70, 0]  # 
		self.LP = self.DIOPEN  # General Definition: 
		self.LPASS = self.DIOPEN  # Owner Definition: 
		
		self.EDGE = [71, 0]  # 
		self.DT = self.EDGE  # General Definition: 
		self.TRENCH = self.EDGE  # Owner Definition: 
		
		self.FRAME = [0, 0]  # 
		self.PAYLOAD = self.FRAME  # General Definition: 
		
		self.NOWG = [150, 0]  # No WG dummy
		self.NOPASS = self.NOWG  # General Definition: No WG dummy
		
		self.NOMET = [151, 0]  # No M1 dummy
		
		self.NOFILL = [152, 0]  # No WG and M1 dummy
		
		
		self.LOGO = [self.WG, self.M2, ]  # Definition: LOGO print on the chip; (WG1; M2)
		self.WG1COR = [self.WG, ]  # Definition: Rib waveguide 150
		self.WG1CLD = [self.SP, ]  # Definition: Rib waveguide 150
		self.WG2COR = [self.WG, ]  # Definition: Rib waveguide 90
		self.WG2CLD = [self.SP, self.RB, ]  # Definition: Rib waveguide 90
		self.WG3 = [self.WG, ]  # Definition: Strip Waveguide
		self.FDTD_Lyr = [self.PAYLOAD, self.WG, [self.SP, self.WG], [self.RB, self.WG], self.GeW, self.CG, ]  # Definition: option
		self.WG1 = [self.WG1COR, self.WG1CLD, ]
		self.WG2 = [self.WG2COR, self.WG2CLD, ]
		self.waveguide_lyr = [self.WG1, self.WG2, self.WG3, ]  # Definition: List the waveguide layers (leave empty if default)
		self.WG_Con_Check = [self.WG, self.WG1COR, self.WG2COR, ]  # Definition: Waveguide layers for connection check

class TECH_Init(object):
	def __init__(self):
		
		self.Wtre = 2  # width for trech beside waveguide core
		self.Biaswg1 = 0  # width bias for WG1
		self.Biaswg2 = 0  # width bias for WG2
		self.Biaswg3 = 0  # width bias for WG3
		self.RCwg1 = 80  # Radius threshold value for Cband WG1 warning
		self.RCwg2 = 10  # Radius threshold value for Cband WG2 warning
		self.RCwg3 = 5  # Radius threshold value for Cband WG3 warning
		self.ROwg1 = 50  # Radius threshold value for Oband WG1 warning
		self.ROwg2 = 10  # Radius threshold value for Oband WG2 warning
		self.ROwg3 = 5  # Radius threshold value for Oband WG3 warning
		self.WCwg1 = 0.7  # Default width of Cband WG1
		self.WCwg2 = 0.5  # Default width of Cband WG2
		self.WCwg3 = 0.5  # Default width of Cband WG3
		self.WOwg1 = 0.6  # Default width of Oband WG1
		self.WOwg2 = 0.41  # Default width of Oband WG2
		self.WOwg3 = 0.41  # Default width of Oband WG3
		self.HSitop = 0.22  # Height of silicon top (Used in FDTD Simulation)
		self.Hwg1etch = 0.07  # Thickness of wg1 etch (Used in FDTD Simulation)
		self.Hwg2etch = 0.13  # Thickness of wg2 etch (Used in FDTD Simulation)
		self.Hwg3etch = 0.22  # Thickness of wg3 etch (Used in FDTD Simulation)
		self.HGe = 0.515  # FDTD
		self.HGeRes = 0.115  #  FDTD
		self.FDTD_material = ['SiO2 (Glass) - Palik','Si (Silicon) - Palik',['Si (Silicon) - Palik','Si (Silicon) - Palik'],['SiO2 (Glass) - Palik','Si (Silicon) - Palik'],'Ge:4.27:0.06', 'W (Tungsten) - CRC']  # FDTD
		self.FDTD_mesh = [5,1,2,2,1,1]  # FDTD
		self.FDTD_zmin = [0,0,0,(self.HSitop-self.Hwg2etch),self.HSitop,(self.HSitop+self.HGe-0.01)]  # FDTD
		self.FDTD_zmax = [0,self.HSitop,(self.HSitop-self.Hwg1etch),self.HSitop,(self.HSitop+self.HGe),(self.HSitop+self.HGe+1)]  # FDTD
		self.bias = {}
		self.bias[str(TECH_Lyr_SITRI.WG1)] = self.Biaswg1
		self.bias[str(TECH_Lyr_SITRI.WG2)] = self.Biaswg2
		self.bias[str(TECH_Lyr_SITRI.WG3)] = self.Biaswg3
		self.Wcld_tre = {}
		self.Wcld_tre[str(TECH_Lyr_SITRI.WG1CLD)] = [2.0]
		self.Wcld_tre[str(TECH_Lyr_SITRI.WG2CLD)] = [2.0, 4.0]


TECH_Lyr_SITRI=TECH_Lyr_Init()
TECH_SITRI=TECH_Init()